using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.ServiceModel.Channels;
using System.Text;
using System.Threading.Tasks;
using Windows.Storage;
using Windows.UI.Popups;
using Xamarin.Forms;

//Register the UWP implementation of ISave with DependencyService
[assembly: Dependency(typeof(GettingStarted.UWP.SaveWindows))]

namespace GettingStarted.UWP
{
    public class SaveWindows : ISave
    {
        StorageFolder folder;
        StorageFile file;

        public async void SaveAsync(MemoryStream stream)
        {
            stream.Position = 0;
            folder = ApplicationData.Current.LocalFolder;
            file = await folder.CreateFileAsync("ExportedImage" + Guid.NewGuid() + ".png", CreationCollisionOption.ReplaceExisting);
            if (file != null)
            {
                Windows.Storage.Streams.IRandomAccessStream fileStream = await file.OpenAsync(FileAccessMode.ReadWrite);
                Stream st = fileStream.AsStreamForWrite();
                st.SetLength(0);
                st.Write((stream as MemoryStream).ToArray(), 0, (int)stream.Length);
                st.Flush();
                st.Dispose();
                fileStream.Dispose();
            }

            MessageDialog dialog = new MessageDialog("The exported image is stored in the location:"+ file.Path);
            await dialog.ShowAsync();
        }

        public string Save(MemoryStream stream)
        {
            return string.Empty;
        }
    }
}
