﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.SfPdfViewer.XForms;
using Xamarin.Forms;

namespace GettingStarted
{
	public partial class MainPage : ContentPage
	{
        Stream fileStream;

        private SfPdfViewer pdfViewerControl;
		public MainPage()
		{
			InitializeComponent();
            fileStream = typeof(App).GetTypeInfo().Assembly.GetManifestResourceStream("GettingStarted.Assets.Xamarin-Forms-Succinctly.pdf");
            // Initialize the SfPdfViewer
            pdfViewerControl = new SfPdfViewer();
            //Load the PDF document as stream
            pdfViewerControl.LoadDocument(fileStream);
            
        }

        protected override void OnAppearing()
        {
            base.OnAppearing();
        }

        private async void Button_Clicked(object sender, EventArgs e)
        {
            // Export the page of PDF document to image with the given index
            Stream stream = pdfViewerControl.ExportAsImage(0);

            if (Device.RuntimePlatform != Device.UWP)
            {
                // Save the image stream to local storage of the device
                string filePath = DependencyService.Get<ISave>().Save(stream as MemoryStream);

                await DisplayAlert("Information", "The exported image is stored in the location:" + filePath, "Ok");
            }
            else
            {
                DependencyService.Get<ISave>().SaveAsync(stream as MemoryStream);
            }
        }
    }
}
